C  MOC_MAIN  PROGRAM CONTROL FOR MOC3D SUBROUTINES
C
C*************************************************************************
C  MOC6CKRP  READ AND PREPARE MOC3D,  CHECK CONSISTENCY
C*************************************************************************
C
      SUBROUTINE MOC6CKRP(IBOUND,DELCOL,DELROW,
cellam
     *  CBNDY,NTFACE,LBNDY,
     *  XFOR,XBAC,YFOR,YBAC,
cellam
     *  SC1,SC2,RF,
     *  CONC,CONINT,CFXHBC,CINFL,
     *  THCK,ALONG,ATRANH,ATRANV,
     *  POR,PNEWC,PNEWR,PNEWL,IGENPT,
     *  FDTMTH,EPSSLV,IDIREC,NCXIT,MAXIT,
     *  SBVL,NEWPTS,NSCOL,NSROW,NSLAY,NODESS,
     *  NCOL,NROW,NLAY,IOUTS,INMOC,
     *  iunit,lcwell,nwelvl,mxwell,lcdrai,ndrnvl,mxdrn,
     *  lcrivr,nrivvl,mxrivr,lcbnds,nghbvl,mxbnd,
     *  lcievt,lsevtf,lscrch,lcirch,lcrech,LCHFBR,
     *  LCFLLC,LCBDFV,LCHDLC,LCBDHV,
     *  ICSTRT,JRF,NODISP,NPNTVL,NPNTCL,NPNTDL,NPNTPL,
     *  IVELFM,ICONFM,IDSPFM,cnoflw,
     *  ICONLY,IFXHED,ISS,NCINFL,INTRPL,IDIM,NPTPND,MOCTYPE,
     *  CC,HY,CI,CIN,CIR,CIRH,CIRL,
     *  IND,MRNO,MRNO0,NBN,NRN, 
     *  IOBLST,OBTEMP,NUMOBS,JUNIT,IOBSFL,NPNTOB,
     *  SRCDCY,KKSTP,NSTP,KKPER,NPER,PERTIM,TOTIM,
     *  HNEW,SUMTCH,BUFF,
     *  DKZO,DKFO,DKZS,
     *  DKFS,IDKRF,IDKZO,IDKFO,IDKZS,IDKFS,
     *  DPCON,DPXRAT,DPPOR,
     *  DPZO,DPFO,
     *  IDPZO,IDPFO,IDPPS)
C     ******************************************************************
C
      DOUBLE PRECISION HNEW
      INTEGER CIN,CI,CIR,CIRH,CIRL,MRNO,MRNO0,IND
      DIMENSION SBVL(4,40)
      DIMENSION IBOUND(NCOL,NROW,NLAY),DELCOL(NCOL),DELROW(NROW),
     *  SC1(NCOL,NROW,NLAY),SC2(NCOL,NROW,NLAY)
      DIMENSION RF(NODESS),
     *  CONC(NODESS),CONINT(NODESS),CINFL(NCINFL),
     *  CFXHBC(NSCOL,NSROW,NSLAY),THCK(NODESS),
     *  ALONG(NSLAY),ATRANH(NSLAY),ATRANV(NSLAY),
     *  POR(NODESS),PNEWC(NEWPTS),PNEWR(NEWPTS),PNEWL(NEWPTS),
     *  IGENPT(NODESS),CC(NCOL,NROW,NLAY),HY(NCOL,NROW,NLAY)
      DIMENSION CI(6,NODESS),CIN(6,NODESS),CIR(19,NBN),
     X     CIRH(10,NBN),CIRL(10,NBN),
     X     MRNO(NODESS),MRNO0(NODESS),IND(NODESS)
      DIMENSION IOBLST(4,NUMOBS),OBTEMP(2,NUMOBS)
      DIMENSION IUNIT(40)
      DIMENSION JUNIT(40)
      DIMENSION HNEW(NCOL,NROW,NLAY),BUFF(2,NUMOBS)
      DIMENSION DKZO(NODESS),DKFO(NODESS),
     1   DKZS(NODESS),DKFS(NODESS)
      DIMENSION DPCON(NODESS),DPXRAT(NODESS),DPPOR(NODESS),
     1   DPZO(NODESS),DPFO(NODESS)
cellam
      DIMENSION XFOR(NSCOL),XBAC(NSCOL),YFOR(NSROW),
     *  YBAC(NSROW),CBNDY(NTFACE),LBNDY(NTFACE)
      COMMON /ELLAM/ CINV,RINV,BINV,HCINV,HRINV,HBINV,
     *               STINIT,ADINIT,STMASS,ADMASS,OLMASS,
     *               AZERO,
     *               NSC,NSR,NSL,NT,NCTF,NRTF,NLTF,
     *               NEIGHB(8,2),NSLOPE(3),
     *               IDTOP,IDMAX,NCOEF,NSCH,NSRH,NSLH
cellam
      COMMON /FLWCOM/LAYCON(200)
      COMMON /MOC3D/ CDEL,RDEL,CNOFLO,CELDIS,FZERO,NZCRIT
      COMMON /SUBGRD/
     *  ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,ISLAY2,ISUBGD
C
      DUM=0  
      CALL MOC6RP(IBOUND,DELCOL,DELROW,
cellam
     *  CBNDY,NTFACE,LBNDY,
     *  XFOR,XBAC,YFOR,YBAC,
cellam
     *   SC1,SC2,RF,
     *   CONC,CONINT,CFXHBC,CINFL,
     *   THCK,ALONG,ATRANH,ATRANV,
     *   POR,PNEWC,PNEWR,PNEWL,IGENPT,
     *  FDTMTH,EPSSLV,IDIREC,NCXIT,MAXIT,
     *  SBVL,NEWPTS,NSCOL,NSROW,NSLAY,NODESS,
     *  NCOL,NROW,NLAY,IOUTS,INMOC,
     *  ICSTRT,JRF,NODISP,
     *  NPNTVL,NPNTCL,NPNTDL,NPNTPL,
     *  IVELFM,ICONFM,IDSPFM,
     *  ICONLY,IFXHED,ISS,NCINFL,INTRPL,IDIM,NPTPND,MOCTYPE,
     *  JUNIT(11),DKZO,DKFO,DKZS,DKFS,
     *  IDKRF,IDKZO,IDKFO,IDKZS,IDKFS,
     *  JUNIT(10),DPCON,DPXRAT,DPPOR,
     *  DPZO,DPFO,IDPZO,IDPFO)
C
      cnoflw=cnoflo
C
CMOC----CHECK FOR CONSISTENCY BETWEEN MODFLOW AND MOC PARAMETERS
      CALL MOC5CK(THCK,POR,
     * IBOUND,CC,HY,
     * NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,
     * IOUTS)
C
C     pointer & variable initialization for unused MODFLOW packages
      if (iunit(2).eq.0) then
         lcwell=1
         nwelvl=1
         mxwell=1
      end if
      if (iunit(3).eq.0) then
         lcdrai=1
         ndrnvl=1
         mxdrn=1
      end if
      if (iunit(4).eq.0) then
         lcrivr=1
         nrivvl=1
         mxrivr=1
      end if
      if (iunit(5).eq.0) then
         lcievt=1
      end if
      if (iunit(7).eq.0) then
         lcbnds=1
         nghbvl=1
         mxbnd=1
      end if
      if (iunit(8).eq.0) then
         lscrch=1
         lcirch=1
         lcrech=1
      end if
        if (iunit(16).eq.0) then
           LCHFBR=1
        end if
        if (iunit(21).eq.0) then
           LCFLLC=1
           LCBDFV=1
           LCHDLC=1
           LCBDHV=1
        end if
C
C.....Pointer initialization for iterative solver
      IF(MOCTYPE.EQ.2)
     X   CALL INIT(IBOUND,
     X     CI,CIN,CIR,CIRH,CIRL,
     X     IND,MRNO,MRNO0,
     X     EPSSLV,MAXIT,IDIREC,
     X     NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,NBN,NRN)
C
CMOC----READ OBSERVATION LOCATIONS
      IF(JUNIT(8).GT.0)
     *   CALL OBS5RP(IOBLST,NUMOBS,
     *                  IOUTS,JUNIT(8),IOBSFL)
C
CMOC----PRINT INITIAL CONCENTRATION DATA
      CALL SMOC6C(CONC,THCK,SBVL,SRCDCY,
     *    KKSTP,NSTP,KKPER,NPER,0,0,0.0,
     *    DELCOL,DELROW,NCOL,NROW,NLAY,
     *    NSCOL,NSROW,NSLAY,IOUTS,JUNIT,PERTIM,TOTIM,DUM,
     *    NPNTCL,ICONFM,ICONLY,
     * IDKZO,IDKFO,IDKZS,IDKFS,
     * IDPZO,IDPFO)
C
CDP----PRINT INITIAL DOUBLE POROSITY CONCENTRATION DATA
      IF(JUNIT(10).GT.0.AND.IDPPS.NE.0) CALL SDP6C(DPCON,
     *    KKSTP,NSTP,KKPER,NPER,0,0,
     *    NSCOL,NSROW,NSLAY,IOUTS,JUNIT,PERTIM,TOTIM,DUM,
     *    NPNTCL,ICONFM,IDPPS)
C
CMOC----WRITE INITIAL CONDITION TO OBSERVATION WELLS
      IF (JUNIT(8).GT.0)
     *CALL SOBS5O(HNEW,CONC,SUMTCH,IOBLST,0,OBTEMP,
     *                  NSCOL,NSROW,NSLAY,NCOL,NROW,NLAY,NUMOBS,IOBSFL,
     *                  NPNTOB,KKSTP,NSTP,NMOV,KKPER,NPER)
C
      RETURN
      END
C
C
C*************************************************************************
C  MOC6INIT  INITIALIZE MOC3D TERMS BASED ON FIRST FLOW SOLUTION
C*************************************************************************
C
      SUBROUTINE MOC6INIT(ICNVG,IUNIT,KSTP,KPER,
     *   HNEW,IBOUND,HOLD,TOP,
     *   THCK,BOT,NSCOL,NSROW,NSLAY,NCOL,NROW,NLAY,
     *   IOUTS,ISS,CONC,RF,POR,SBVL,JRF,
     *   PC,PR,PL,PCONC,IPTID,NPCELL,
     *   PNEWC,PNEWR,PNEWL,LIMBO,
     *   NEWPTS,NPMAX,NLIMBO,NP,MOCTYPE,
     *   JUNIT,KKPER,NPER,KKSTP,NSTP,IIMOV,NMOV,TIMV,NPNTPL,SUMTCH)
C     ******************************************************************
C
      DOUBLE PRECISION HNEW
      COMMON /MOC3D/ CDEL,RDEL,CNOFLO,CELDIS,FZERO,NZCRIT
      COMMON /SUBGRD/
     *  ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,ISLAY2,ISUBGD
      DIMENSION HNEW(NCOL,NROW,NLAY),
     *  IBOUND(NCOL,NROW,NLAY),
     *  HOLD(NCOL,NROW,NLAY),
     *  TOP(NCOL,NROW,NLAY),
     *  THCK(NSCOL,NSROW,NSLAY),
     *  BOT(NCOL,NROW,NLAY),
     *  CONC(NSCOL,NSROW,NSLAY),
     *  RF(NSCOL,NSROW,NSLAY),POR(NSCOL,NSROW,NSLAY),
     *  SBVL(4,40)
      DIMENSION PC(NPMAX),PR(NPMAX),PL(NPMAX),PCONC(NPMAX),
     *     IPTID(NPMAX),NPCELL(NSCOL,NSROW,NSLAY),
     *   PNEWC(NEWPTS),PNEWR(NEWPTS),PNEWL(NEWPTS),LIMBO(NLIMBO)
      DIMENSION IUNIT(40)
      DIMENSION JUNIT(40)
C
CMOC----SET INITIAL SATURATED THICKNESS FOR WATER-TABLE CELLS
      IF(ICNVG.EQ.1.AND.IUNIT(15).GT.0.AND.KPER.EQ.1) THEN
         CALL SMOC5TK(HNEW,IBOUND,HOLD,TOP,
     *     THCK,BOT,NSCOL,NSROW,NSLAY,NCOL,NROW,NLAY,
     *     IOUTS,ISS)
C
CMOC----CALCULATE INITIAL SOLUTE MASS STORED FOR CHEMICAL MASS BALANCE
cellam (call to do mb init is within "move" loop)
       IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
         CALL SMOC6IM(IBOUND,CONC,THCK,RF,
     *     POR,SBVL,NSCOL,NSROW,NSLAY,NCOL,NROW,NLAY,IOUTS,JRF)
C
CMOC----CALL SMOC5GP TO GENERATE INITIAL PARTICLES
         IIMOV=0
         CALL SMOC5GP(PC,PR,PL,PCONC,CONC,
     *     IPTID,NPCELL,IBOUND,
     *     PNEWC,PNEWR,PNEWL,LIMBO,NCOL,NROW,NLAY,
     *     NSCOL,NSROW,NSLAY,NEWPTS,NPMAX,NLIMBO,IOUTS,NP)
C
CMOC----DUMP INITIAL PARTICLE LOCATIONS  (IIMOV=0)
         IF(JUNIT(4).GT.0.AND.IIMOV.EQ.0)
     *      CALL SMOC5P(PC,PR,PL,PCONC,
     *                  JUNIT(4),KKPER,NPER,KKSTP,NSTP,IIMOV,NMOV,TIMV,
     *                  NP,SUMTCH,NPNTPL,0)
         IF(JUNIT(5).GT.0.AND.IIMOV.EQ.0)
     *      CALL SMOC5P(PC,PR,PL,PCONC,
     *                  JUNIT(5),KKPER,NPER,KKSTP,NSTP,IIMOV,NMOV,TIMV,
     *                  NP,SUMTCH,NPNTPL,1)
C
CMOC----END INITIALIZE TRANSPORT TERMS
       END IF
       ENDIF
cellam
C
      RETURN
      END
C
C
C*************************************************************************
C  MOC5VELO  CALCULATE FLOWS ACROSS BOUNDARIES OF SUBGRID, 
C            CALCULATE AND PRINT VELOCITIES
C*************************************************************************
C
      SUBROUTINE MOC6VELO(CTCFLO,BUFF,LOCBDY,
     *      IDIR,ID,NCOL,NROW,NLAY,IC1,IC2,IR1,IR2,IL1,
     *      IL2,NFACES,NCINFL,
     *      THCK,POR,RF,VC,VR,VL,
     *      IBOUND,NSCOL,NSROW,NSLAY,IOUTS,NTIMV,
     *      VCMAX,VRMAX,VLMAX,TLMIN,
     *      MAXVCJ,MAXVCI,MAXVCK,MAXVRJ,MAXVRI,MAXVRK,
     *      MAXVLJ,MAXVLI,MAXVLK,
     *      DELT,KKSTP,KKPER,NSTP,NPER,TIMV,TOTIM,ITCD,
     *      NPNTVL,IVELFM,JUNIT,
cellam
     *      MOCTYPE,TCMIN,TRMIN,DELCOL,DELROW)
cellam  
C     ******************************************************************
C
      DIMENSION BUFF(NCOL,NROW,NLAY),CTCFLO(NFACES),LOCBDY(3,NFACES),
     *   THCK(NSCOL,NSROW,NSLAY),
     *   POR(NSCOL,NSROW,NSLAY),RF(NSCOL,NSROW,NSLAY),
     *   VC(NSCOL+1,NSROW,NSLAY),VR(NSCOL,NSROW+1,NSLAY),
     *   VL(NSCOL,NSROW,NSLAY+1),
     *   IBOUND(NCOL,NROW,NLAY)
      dimension junit(40)
cellam
      DIMENSION DELCOL(NCOL),DELROW(NROW)
      COMMON /ELLAM/ CINV,RINV,BINV,HCINV,HRINV,HBINV,
     *               STINIT,ADINIT,STMASS,ADMASS,OLMASS,
     *               AZERO,
     *               NSC,NSR,NSL,NT,NCTF,NRTF,NLTF,
     *               NEIGHB(8,2),NSLOPE(3),
     *               IDTOP,IDMAX,NCOEF,NSCH,NSRH,NSLH
cellam
C
      COMMON /FLWCOM/LAYCON(200)
      COMMON /MOC3D/ CDEL,RDEL,CNOFLO,CELDIS,FZERO,NZCRIT
      COMMON /SUBGRD/
     *  ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,ISLAY2,ISUBGD
C
CMOC----CALCULATE FLOWS ACROSS BOUNDARIES OF SUBGRID
            IF(NCINFL.GT.0)
     *        CALL SMOC5BY(CTCFLO,BUFF,LOCBDY,
     *          IDIR,ID,NCOL,NROW,NLAY,IC1,IC2,IR1,IR2,IL1,
     *          IL2,NFACES)
C
CMOC----CALCULATE VELOCITIES
            CALL VELO(THCK,BUFF,POR,RF,
     *         VC,VR,VL,IBOUND,
     *         NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,IOUTS,
     *         VCMAX,VRMAX,VLMAX,TLMIN,IDIR,
     *         MAXVCJ,MAXVCI,MAXVCK,MAXVRJ,MAXVRI,MAXVRK,
     *         MAXVLJ,MAXVLI,MAXVLK,
     *         JUNIT(11),
cellam
     *         MOCTYPE,TCMIN,TRMIN,DELCOL,DELROW)
cellam  
C
CMOC----PRINT VELOCITIES
            CALL SMOC6V(THCK,BUFF,POR,RF,
     *         VC,VR,VL,IBOUND,DELT,
     *         KKSTP,KKPER,NSTP,NPER,
     *         NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,IOUTS,NTIMV,
     *         TIMV,VCMAX,VRMAX,VLMAX,TLMIN,IDIR,TOTIM,
     *         MAXVCJ,MAXVCI,MAXVCK,MAXVRJ,MAXVRI,MAXVRK,
     *         MAXVLJ,MAXVLI,MAXVLK,ITCD,
     *         NPNTVL,IVELFM,JUNIT,
cellam
     *         MOCTYPE,TCMIN,TRMIN,DELCOL,DELROW)
cellam  
C
      RETURN
      END
C
C
C*************************************************************************
C  MOC5DISP   CALCULATE AND PRINT DISPERSION COEFFICIENTS
C*************************************************************************
C
      SUBROUTINE MOC6DISP(DISPCC,
     *             DISPCR,DISPCL,DISPRR,DISPRC,DISPRL,DISPLL,
     *             DISPLC,DISPLR,THCK,ALONG,ATRANH,ATRANV,
     *             POR,RF,VC,VR,VL,IBOUND,moctype,
     *             DELT,NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,
     *             IOUTS,NTIMD,TIMDC,NODISP,DIFFUS,TIMV,
     *             KKSTP,NSTP,KKPER,NPER,IDSPFM,NPNTDL,
     *             DELCOL,DELROW,
cgzh
     *             HFBUNIT,HFBR,NHFB)   
cgzh

C     ******************************************************************
C
      DIMENSION
     *  DISPCC(NSCOL,NSROW,NSLAY),DISPCR(NSCOL,NSROW,NSLAY),
     *  DISPCL(NSCOL,NSROW,NSLAY),DISPRR(NSCOL,NSROW,NSLAY),
     *  DISPRC(NSCOL,NSROW,NSLAY),DISPRL(NSCOL,NSROW,NSLAY),
     *  DISPLL(NSCOL,NSROW,NSLAY),DISPLC(NSCOL,NSROW,NSLAY),
     *  DISPLR(NSCOL,NSROW,NSLAY),THCK(NSCOL,NSROW,NSLAY),
     *  ALONG(NSLAY),ATRANH(NSLAY),ATRANV(NSLAY),
     *  POR(NSCOL,NSROW,NSLAY),RF(NSCOL,NSROW,NSLAY),
     *  VC(NSCOL+1,NSROW,NSLAY),VR(NSCOL,NSROW+1,NSLAY),
     *  VL(NSCOL,NSROW,NSLAY+1),IBOUND(NCOL,NROW,NLAY)
cellam
      DIMENSION DELCOL(NCOL),DELROW(NROW)
cgzh
        DIMENSION HFBR(5,NHFB)
      COMMON /ELLAM/ CINV,RINV,BINV,HCINV,HRINV,HBINV,
     *               STINIT,ADINIT,STMASS,ADMASS,OLMASS,
     *               AZERO,
     *               NSC,NSR,NSL,NT,NCTF,NRTF,NLTF,
     *               NEIGHB(8,2),NSLOPE(3),
     *               IDTOP,IDMAX,NCOEF,NSCH,NSRH,NSLH
cellam
C
      COMMON /MOC3D/ CDEL,RDEL,CNOFLO,CELDIS,FZERO,NZCRIT
      COMMON /SUBGRD/
     *  ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,ISLAY2,ISUBGD
cgzh
      COMMON/HFBCOM/NBRLAY(200)
cgzh
C
CMOC----CALCULATE DISPERSION COEFFICIENTS
      CALL DSP6FM(
     *    DISPCC,DISPCR,DISPCL,DISPRR,DISPRC,DISPRL,
     *    DISPLL,DISPLC,DISPLR,THCK,ALONG,ATRANH,ATRANV,
     *    POR,RF,VC,VR,VL,IBOUND,moctype,
     *    DELT,NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,
     *    IOUTS,NTIMD,TIMDC,NODISP,DIFFUS,
cellam
     *    DELCOL,DELROW)
cellam  
cgzh
C correct dispersion coefficients for HFB package (set disp coef=0.0 where there is a barrier)
c      IF(HFBUNIT.GT.0) CALL DSP6HFB(IBOUND,
c     *    DISPCC,DISPCR,DISPRR,DISPRC,DISPCL,DISPRL,
c     *    POR,THCK,DIFFUS,DELCOL,DELROW,
c     *    NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,IOUTS,    
c     *    HFBR,NHFB)
C
CMOC----PRINT DISPERSION COEFFICIENTS
      CALL SMOC5D(DISPCC,
     *    DISPCR,DISPCL,DISPRR,DISPRC,DISPRL,DISPLL,
     *    DISPLC,DISPLR,
     *    KKSTP,NSTP,KKPER,NPER,NSCOL,NSROW,NSLAY,
     *    IOUTS,NODISP,IDSPFM,NPNTDL)
C
      RETURN
      END
C
C
C     ****************************************************************
C
      SUBROUTINE MOC5LDAS(
     *     IBOUND,NCOL,NROW,NLAY,
     *     DISPCC,DISPCR,DISPCL,DISPRR,DISPRC,DISPRL,
     *     DISPLL,DISPLC,DISPLR,
     *     NSCOL,NSROW,NSLAY,
     X     THCK,POR,RF,TIMV,
     *     VA,VAD,RHS,CIN,MRNO,FDTMTH,NRN,NODESS)
C
      DIMENSION
     *  DISPCC(NSCOL,NSROW,NSLAY),DISPCR(NSCOL,NSROW,NSLAY),
     *  DISPCL(NSCOL,NSROW,NSLAY),DISPRR(NSCOL,NSROW,NSLAY),
     *  DISPRC(NSCOL,NSROW,NSLAY),DISPRL(NSCOL,NSROW,NSLAY),
     *  DISPLL(NSCOL,NSROW,NSLAY),DISPLC(NSCOL,NSROW,NSLAY),
     *  DISPLR(NSCOL,NSROW,NSLAY),  THCK(NSCOL,NSROW,NSLAY),
     *     POR(NSCOL,NSROW,NSLAY),    RF(NSCOL,NSROW,NSLAY),
     *  IBOUND(NCOL,NROW,NLAY)
C
      INTEGER CIN,MRNO
      DIMENSION VA(6,*),VAD(NODESS),RHS(0:NODESS),CIN(6,*),MRNO(*)
C
         NXY=NSCOL*NSROW
        CALL LOADT(
     *     IBOUND,NCOL,NROW,NLAY,
     *     DISPCC,DISPCR,DISPCL,DISPRR,DISPRC,DISPRL,
     *     DISPLL,DISPLC,DISPLR,
     *     NSCOL,NSROW,NSLAY,
     *     THCK,POR,RF,TIMV)
        CALL ASEMBL(
     X     DISPCC,DISPRR,DISPLL,
     X     VA,VAD,RHS,CIN,IBOUND,MRNO,FDTMTH,
     X     NSCOL,NSROW,NSLAY,NXY,NODESS,NRN,
     X     NCOL,NROW,NLAY)
C
      RETURN
      END
C
C
C*************************************************************************
C  MOC5MVOT PERFORM EACH MOVE, APPROXIMATE CHANGES IN CONCENTRATION,
C           COMPUTE CUMULATIVE SOLUTE MASS BALANCE,PRINT OUTPUT
C*************************************************************************
C
      SUBROUTINE MOC6MVOT(SRCFLO,SNKFLO,RF,POR,THCK,
     *  VCMAX,VRMAX,VLMAX,TLMIN,TIMV,NTIMV,ITCD,
     *  MAXVCJ,MAXVCI,MAXVCK,MAXVRJ,MAXVRI,MAXVRK,MAXVLJ,MAXVLI,MAXVLK,
     *  TIMDC,NTIMD,NMOV,SUMTCH,NSCOL,NSROW,NSLAY,IOUTS,
     *  TOTIM,DELT,NODISP,DIFFUS,DECAY,ICONLY,MOCTYPE,
     *  IIMOV,CONC,CNOLD,NPCELL,NPOLD,LOCHFB,
     *  INTRPL,PC,PR,PL,PCONC,IPTID,
     *  VC,VR,VL,CINFL,IBOUND,DELCOL,DELROW,
     *  SUMC,LIMBO,PNEWC,PNEWR,PNEWL,IGENPT,
     *  NEWPTS,NCOL,NROW,NLAY,NPMAX,NLIMBO,NP,NCINFL,IABOVE,IBELOW,
     *  CNCNC,SRCSOL,EVTFLO,IEVT,SRCDCY,NEVTOP,
     *  KKSTP,KKPER,SNKRAT,RS,FDTMTH,CAVG,
     *  DISPCC,DISPCR,DISPCL,DISPRR,DISPRC,DISPRL,
     *  DISPLL,DISPLC,DISPLR,VA,VAD,RHS,CIN,
     *  MRNO,AP,PP,RA,RR,SS,
     *  XX,WW,WORK,CI,CIR,CIRH,CIRL,
     *  NCXIT,EPSSLV,MAXIT,NBN,NRN,
     *  CFXHBC,CHDFLO,CTCFLO,LOCBDY,
     *  RECH,CRECH,IRCH,NRCHOP,
     *  WELL,MXWELL,NWELLS,NWELVL,IWELLC,
     *  RIVR,MXRIVR,NRIVER,NRIVVL,IRIVRC,
     *  DRAI,MXDRN,NDRAIN,NDRNVL,
     *  BNDS,MXBND,NBOUND,NGHBVL,IBNDSC,
     *  IFLLOC,BDFV,NFLW,IFHBD4,IFHBFC,
     *  IHDLOC,BDHV,NHED,NFHBX2,IFHBHC,
     *  IUNIT,JRF,SBVL,NFACES,NSTP,NPER,JUNIT,PERTIM,
     *  NPNTCL,ICONFM,HNEW,IOBLST,OBTEMP,
     *  NUMOBS,IOBSFL,NPNTPL,NODESS,NPNTOB,
     *  DKZO,DKFO,DKZS,
     *  DKFS,IDKZO,IDKFO,IDKZS,IDKFS,
     *  AGER8,
     *  DPCON,DPXRAT,DPPOR,
     *  DPZO,DPFO,
     *  IDPZO,IDPFO,IDPPS,
cellam
     *  RHSE,RHSO,NTFACE,DIAGO,DIAGST,DIAGDS,
     *  IDBNDY,LBNDY,
     *  XFOR,XBAC,YFOR,YBAC,CBNDY,NZIN,
     *  NONU,SAV,IACT,CFOR,RFOR,TFOR,
     *  CONLAY,VOL,RWORK,LENW,JA,IA,A,IDIM,
     *  NELT,NODES,JAS,IAS,AS,NELTS,LENIW,IWORK,NRFLG)
cellam
C     ******************************************************************
C
      DOUBLE PRECISION DECAY
      DOUBLE PRECISION HNEW
      INTEGER CIN,CI,CIR,CIRH,CIRL,MRNO
      DIMENSION
     *  SRCFLO(NSCOL,NSROW,NSLAY),SNKFLO(NSCOL,NSROW,NSLAY),
     *  SRCSOL(NSCOL,NSROW,NSLAY),
     *  RF(NSCOL,NSROW,NSLAY),POR(NSCOL,NSROW,NSLAY),
     *  THCK(NSCOL,NSROW,NSLAY),IBOUND(NCOL,NROW,NLAY),
     *  CONC(NSCOL,NSROW,NSLAY),CNOLD(NSCOL,NSROW,NSLAY)
      DIMENSION BDFV(IFHBD4,NFLW),IFLLOC(4,NFLW)
      DIMENSION BDHV(NFHBX2,NHED),IHDLOC(4,NHED)
      DIMENSION
     *  NPCELL(NSCOL,NSROW,NSLAY),NPOLD(NSCOL,NSROW,NSLAY),
     *  PC(NPMAX),PR(NPMAX),PL(NPMAX),PCONC(NPMAX),IPTID(NPMAX),
     *  VC(NSCOL+1,NSROW,NSLAY),VR(NSCOL,NSROW+1,NSLAY),
     *  VL(NSCOL,NSROW,NSLAY+1),
     *  CINFL(NCINFL),CAVG(NSCOL,NSROW,NSLAY),
     *  SUMC(NSCOL,NSROW,NSLAY),IGENPT(NSCOL,NSROW,NSLAY),
     *  LIMBO(NLIMBO),PNEWC(NEWPTS),PNEWR(NEWPTS),PNEWL(NEWPTS),
     *  CNCNC(NSCOL,NSROW,NSLAY),
     *  EVTFLO(NSCOL,NSROW),IEVT(NROW,NCOL)
      DIMENSION
     *  DISPCC(NSCOL,NSROW,NSLAY),DISPCR(NSCOL,NSROW,NSLAY),
     *  DISPCL(NSCOL,NSROW,NSLAY),DISPRR(NSCOL,NSROW,NSLAY),
     *  DISPRC(NSCOL,NSROW,NSLAY),DISPRL(NSCOL,NSROW,NSLAY),
     *  DISPLL(NSCOL,NSROW,NSLAY),DISPLC(NSCOL,NSROW,NSLAY),
     *  DISPLR(NSCOL,NSROW,NSLAY)  
      DIMENSION CI(6,*),CIR(19,*),CIRH(10,*),CIRL(10,*),
     X     RS(NODESS),VA(6,*),
     X     VAD(NODESS),RHS(0:NODESS),CIN(6,*),MRNO(*),
     X     AP(*),PP(*),RA(10,*),RR(*),SS(*),
     X     XX(*),WW(*),WORK(*)
      DIMENSION SBVL(4,40),IUNIT(40),JUNIT(40)
      DIMENSION WELL(NWELVL,MXWELL),RIVR(NRIVVL,MXRIVR),
     *  DRAI(NDRNVL,MXDRN),BNDS(NGHBVL,MXBND),
     *  RECH(NCOL,NROW),CRECH(NSCOL,NSROW),IRCH(NCOL,NROW),
     *  CHDFLO(NSCOL,NSROW,NSLAY),CTCFLO(NFACES),
     *  CFXHBC(NSCOL,NSROW,NSLAY),LOCHFB(NSCOL,NSROW,NSLAY,2)
      DIMENSION HNEW(NCOL,NROW,NLAY),IOBLST(4,NUMOBS),OBTEMP(2,NUMOBS)
      DIMENSION DELCOL(NCOL),DELROW(NROW)
      DIMENSION DKZO(NSCOL,NSROW,NSLAY),
     *  DKFO(NSCOL,NSROW,NSLAY),
     1   DKZS(NSCOL,NSROW,NSLAY),DKFS(NSCOL,NSROW,NSLAY)
      DIMENSION DPCON(NSCOL,NSROW,NSLAY),DPXRAT(NSCOL,NSROW,NSLAY),
     *  DPPOR(NSCOL,NSROW,NSLAY),
     1   DPZO(NSCOL,NSROW,NSLAY),DPFO(NSCOL,NSROW,NSLAY)
C
cellam
      DIMENSION RHSE(NODESS),RHSO(NTFACE),DIAGO(NTFACE),
     * DIAGST(27,NODESS),DIAGDS(27,NODESS),
     * IDBNDY(NFACES),LBNDY(NTFACE),
     * XFOR(NSCOL),XBAC(NSCOL),YFOR(NSROW),YBAC(NSROW),
     * CBNDY(NTFACE),NZIN(NODESS),NONU(2,32*NFACES),
     * SAV(32*NFACES),IACT(NSCOL,NSROW,2),
     * CFOR(NSCOL-1,NSROW,2),RFOR(NSCOL,NSROW-1,2),
     * TFOR(NSCOL,NSROW),CONLAY(2*NSCOL-1,2*NSROW-1,3),
     * VOL(NSCOL,NSROW,2),RWORK(LENW),JA(NODESS+1),IA(27*NODESS),
     * A(27*NODESS),JAS(1+NODESS),IAS(27*NODESS),AS(27*NODESS),
     * IWORK(LENIW)
      COMMON /ELLAM/ CINV,RINV,BINV,HCINV,HRINV,HBINV,
     *               STINIT,ADINIT,STMASS,ADMASS,OLMASS,
     *               AZERO,
     *               NSC,NSR,NSL,NT,NCTF,NRTF,NLTF,
     *               NEIGHB(8,2),NSLOPE(3),
     *               IDTOP,IDMAX,NCOEF,NSCH,NSRH,NSLH
cellam 
      COMMON /MOC3D/ CDEL,RDEL,CNOFLO,CELDIS,FZERO,NZCRIT
      COMMON /SUBGRD/
     *  ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,ISLAY2,ISUBGD
C
CMOC----UPDATE TRANSPORT TIME, SAVE CURRENT CONCENTRATION AND NUMBER
CMOC----OF PARTICLES PER CELL (NPCELL); FOR ELLAM, INIT
CMOC----MASS BALANCE ACCUMULATORS
C
C Print progress line
C
C Two compiler-specific versions are presented: one for Lahey 
C Fortran and the other for Visual Fortran.  If you are using a 
C different compiler, a generic write and format are provided below.
C  
CGWT----THIS FORMAT STRUCTURE WORKS WITH LAHEY FORTRAN
c      WRITE(*,99) IIMOV,NMOV,KKSTP,NSTP,KKPER,NPER
c  99  FORMAT("+",' MOVE ',I7,' OF ',I7,
c     1       '; STEP ',I7,' OF ',I7,
c     2       '; PERIOD ',I5,' OF ',I5)
C
CGWT----THIS FORMAT STRUCTURE WORKS WITH COMPAQ VISUAL FORTRAN
C The CHAR(13) is ascii escape meaning "go to beginning of line".
C The $ descriptor supresses line feeds.
C This should keep the progress line printing on one line.
C Some compilers/systems may not understand the ascii escape character,
C also, '$' is non-standard and may cause problems with some compilers.
C
      WRITE(*,99) CHAR(13),IIMOV,NMOV,KKSTP,NSTP,KKPER,NPER
  99  FORMAT(A,' MOVE ',I7,' OF ',I7,
     1       '; STEP ',I7,' OF ',I7,
     2       '; PERIOD ',I5,' OF ',I5,$)
C
C The four commented lines below are standard fortran and can be used
C to replace the write statement.  However, the lines will scroll down 
C the screen.
C
CGWT----USE THIS FORMAT STRUCTURE WITH ANY FORTRAN COMPILER
c      WRITE(*,99) IIMOV,NMOV,KKSTP,NSTP,KKPER,NPER
c  99  FORMAT(' MOVE ',I7,' OF ',I7,
c     1       '; STEP ',I7,' OF ',I7,
c     2       '; PERIOD ',I5,' OF ',I5)
C
C
      CALL MOC6AD(CONC,CNOLD,NPCELL,NPOLD,NSCOL,NSROW,NSLAY,
     *   MOCTYPE,TIMV,SUMTCH,IOUTS,IIMOV,NMOV,TOTIM)
cellam
C SKIP IF ELLAM
      IF(MOCTYPE.EQ.3) GO TO 100
cellam
C
C  age all particles and nodes
      IF(JUNIT(9).GT.0) then
        DAGE=AGER8*TIMV
        CALL AGE6AP(PC,PR,PL,PCONC,CONC,IBOUND,SBVL(1,17),
     *              THCK,POR,DAGE,
     *    NCOL,NROW,NLAY,NP,NSCOL,NSROW,NSLAY)
      END IF
C
CMOC----ADVECT PARTICLES TO NEW LOCATIONS AND COMPUTE CONCENTRATIONS
CMOC----AT END OF MOVE WITHOUT SINK/SOURCES OR DISPERSION
CMOC----DECAY PARTICLE CONCENTRATIONS
C
CMOC----CHECK FLAG FOR INTERPOLATION SCHEME;
CMOC----INTRPL=1:LINEAR INTRPL=2:BILINEAR
      IF (INTRPL.EQ.1) THEN
         CALL MOVE(PC,PR,PL,PCONC,IPTID,
     *     VC,VR,VL,RF,THCK,POR,
     *     CINFL,SRCFLO,SNKFLO,CONC,CAVG,IBOUND,
     *     CNOLD,SUMC,NPCELL,NPOLD,LIMBO,
     *     PNEWC,PNEWR,PNEWL,IGENPT,NEWPTS,
     *     NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,NPMAX,NLIMBO,IOUTS,
     *     DECAY,IIMOV,TIMV,NP,NCINFL,IABOVE,IBELOW,
     *     VCMAX,VRMAX,TLMIN,ICONLY,
     *     DKFO,DKFS,JUNIT(11),IDKFO,IDKFS)
      ELSE
         CALL MOVEBI(PC,PR,PL,PCONC,IPTID,
     *     VC,VR,VL,RF,THCK,POR,
     *     CINFL,SRCFLO,SNKFLO,CONC,CAVG,IBOUND,
     *     CNOLD,SUMC,NPCELL,NPOLD,LIMBO,
     *     PNEWC,PNEWR,PNEWL,IGENPT,NEWPTS,
     *     NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,NPMAX,NLIMBO,IOUTS,
     *     DECAY,IIMOV,TIMV,NP,NCINFL,IABOVE,IBELOW,
     *     VCMAX,VRMAX,TLMIN,ICONLY,
     *     DKFO,DKFS,JUNIT(11),IDKFO,IDKFS)
      ENDIF
C
CMOC----CLEAR CNCNC ARRAY IF DISPERSION OR SINK/SOURCES ACTIVE
      IF(ICONLY.NE.1.OR.NODISP.NE.1.OR.DIFFUS.NE.0.0)
     *  CALL SMOC5Z(CNCNC,NSCOL,NSROW,NSLAY,0.0)
C
CMOC----APPROXIMATE CHANGES IN CONCENTRATION DUE TO FLUID SINK/SOURCES
      IF(MOCTYPE.EQ.1) THEN
        IF(ICONLY.NE.1) CALL SRC6AP(IBOUND,SRCFLO,SRCSOL,
     *  SNKFLO,RF,CONC,THCK,POR,CNCNC,
     *  CNOLD,CAVG,EVTFLO,IEVT,SRCDCY,
     *  NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,NEVTOP,KKSTP,KKPER,IOUTS,
     *  IIMOV,TIMV,DECAY,SNKRAT)
      ELSEIF(MOCTYPE.EQ.2) THEN
C.....At beginning of time step, load right-hand-side terms with explicit
C.....     data and with explicit source/sink terms
        IF(ICONLY.NE.1) CALL SRC6IAP(IBOUND,SRCFLO,SRCSOL,
     *  SNKFLO,RF,CONC,THCK,POR,
     *  CNOLD,CAVG,EVTFLO,IEVT,SRCDCY,
     *  NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,NEVTOP,
     *  TIMV,DECAY,SNKRAT,
     X     RS,FDTMTH,VAD,MRNO,NODESS,IIMOV)
      ENDIF
C
C    APPROXIMATE CHANGES IN CONCENTRATION DUE TO ZERO-ORDER GROWTH
      IF(JUNIT(11).GT.0) THEN
        IF(IDKZO.EQ.1.OR.IDKZS.EQ.1) THEN
          IF(MOCTYPE.EQ.1) THEN
            CALL DK6AP(IBOUND,CNCNC,
     *         CAVG,DKZO,DKZS,RF,THCK,POR,
     *         DKZOIN,DKZOOUT,DKZSIN,DKZSOUT,
     *         NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,KKSTP,KKPER,
     *         IIMOV,TIMV,IDKZO,IDKZS)
          ELSE IF(MOCTYPE.EQ.2) THEN
            CALL DK6IAP(IBOUND,CAVG,DKZO,DKZS,RF,
     *         THCK,POR,DKZOIN,DKZOOUT,DKZSIN,DKZSOUT,
     *         NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,KKSTP,KKPER,
     *         TIMV,IDKZO,IDKZS,
     X  RS,FDTMTH,VAD,MRNO,NODESS,IIMOV)
          END IF
          CALL DK6MB(SBVL,DKZOIN,DKZOOUT,DKZSIN,DKZSOUT,IDKZO,IDKZS)
        END IF
      END IF
C  DOUBLE POROSITY
      IF(JUNIT(10).GT.0) THEN
          IF(MOCTYPE.EQ.1) THEN
        CALL DP6AP(IBOUND,
     *  DPCON,DPXRAT,DPPOR,DPZO,DPFO,
     *  RF,CAVG,THCK,POR,CNCNC,
     *  NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,
     *  KSTP,KPER,IOUTS,IIMOV,TIMV,
     *  RMASS,ZODPIN,ZODPOUT,FODPIN,FODPOUT,
     *  IDPZO,IDPFO)
        CALL DP6MB(SBVL,
     *    RMASS,ZODPIN,ZODPOUT,FODPIN,FODPOUT,
     *    IDPZO,IDPFO)
        ELSE
            CALL DP6IAP(IBOUND,
     *  DPCON,DPXRAT,DPPOR,DPZO,DPFO,
     *  RF,CAVG,THCK,POR,
     *  NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,
     *  KSTP,KPER,IOUTS,IIMOV,TIMV,
     *  ZODPIN,ZODPOUT,IDPZO,IDPFO,
     X  RS,FDTMTH,VAD,MRNO,NODESS)
          END IF
C
      END IF
C
CMOC----APPROXIMATE CHANGES IN CONCENTRATION DUE TO DISPERSION
      IF (MOCTYPE.EQ.1) THEN
c       IF(IUNIT(16).GT.0) THEN
C CALL HFB-SPECIFIC DSP ROUTINE
c        IF(NODISP.NE.1.OR.DIFFUS.NE.0.0) CALL DSP6APH(
c     *    DISPCC,DISPCR,DISPCL,DISPRR,DISPRC,DISPRL,
c     *    DISPLL,DISPLC,DISPLR,THCK,POR,RF,
c     *    CONC,CNCNC,IBOUND,CAVG,LOCHFB,
c     *    NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,
c     *    IOUTS,KKSTP,KKPER,IIMOV,TIMV,NODISP)
c         ELSE
C CALL **NON** HFB-SPECIFIC DSP ROUTINE
        IF(NODISP.NE.1.OR.DIFFUS.NE.0.0) CALL DSP6AP(
     *    DISPCC,DISPCR,DISPCL,DISPRR,DISPRC,DISPRL,
     *    DISPLL,DISPLC,DISPLR,THCK,POR,RF,
     *    CONC,CNCNC,IBOUND,CAVG,
     *    NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,
     *    IOUTS,KKSTP,KKPER,IIMOV,TIMV,NODISP)
c         ENDIF
      ELSEIF (MOCTYPE.EQ.2) THEN
CMOC----APPROXIMATE CHANGES IN CONCENTRATION DUE TO DISPERSION-IMPLICIT
        NXY=NSCOL*NSROW
        CALL RHSN(CAVG,DISPCC,DISPRR,DISPLL,RS,
     *      NSCOL,NSROW,NSLAY,NXY,NODESS)
C.....Start the solution of c equations for current time step
C.....Do the concentration cycle
        DO 35 ITRN=1,NCXIT
c                IF(IUNIT(16).EQ.0) THEN
                  IF(ITRN.EQ.1) THEN
                        CALL CR5DSP(CAVG,CNCNC,
     X       DISPCR,DISPCL,DISPRC,DISPRL,DISPLC,DISPLR,
     X         RS,RHS,CIN,IBOUND,MRNO,
     X         NSCOL,NSROW,NSLAY,NXY,NODESS,NRN)
                  ELSE
                        CALL CR5DSP(CONC,CNCNC,
     X         DISPCR,DISPCL,DISPRC,DISPRL,DISPLC,DISPLR,
     X         RS,RHS,CIN,IBOUND,MRNO,
     X         NSCOL,NSROW,NSLAY,NXY,NODESS,NRN)
                  ENDIF
cgzh if hfb active, separate routine
c                ELSE
c                  IF(ITRN.EQ.1) THEN
c                        CALL CR5DSPH(CAVG,CNCNC,
c     X         DISPCR,DISPCL,DISPRC,DISPRL,DISPLC,DISPLR,
c     X         RS,RHS,CIN,IBOUND,MRNO,
c     X         NSCOL,NSROW,NSLAY,NXY,NODESS,NRN,LOCHFB)
c                  ELSE
c                        CALL CR5DSPH(CONC,CNCNC,
c     X         DISPCR,DISPCL,DISPRC,DISPRL,DISPLC,DISPLR,
c     X         RS,RHS,CIN,IBOUND,MRNO,
c     X         NSCOL,NSROW,NSLAY,NXY,NODESS,NRN,LOCHFB)
c                  ENDIF
c                END IF
C.....Solve the matrix equations
C.....Red-black reduced  conjugate gradient solution
           CALL CGRIES(VA,VAD,RHS,AP,PP,RA,RR,SS,XX,WW,WORK,
     X     EPSSLV,MAXIT,CI,CIR,CIRL,CIRH,NODESS,NRN,NBN,
     X     IOUTS,ITRN,NCXIT)
C
           DO 90 M=1,NODESS
            MA=MRNO(M)
            CALL MTOIJK(M,I,J,K,NSCOL,NSROW)
            CNCNC(I,J,K)=RHS(MA)
   90      CONTINUE
   35   CONTINUE
C.....End of NCXIT-cycle solution loop
      ENDIF
C
C  UPDATE DOUBLE POROSITY CONCENTRATIONS FOR IMPLICIT MOCTYPE=2
      IF(JUNIT(10).GT.0.AND.MOCTYPE.EQ.2) THEN
          CALL DP6IUP(IBOUND,
     *  DPCON,DPXRAT,DPPOR,DPZO,DPFO,
     *  RF,CAVG,CNCNC,THCK,POR,
     *  NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,
     *  KSTP,KPER,IOUTS,IIMOV,TIMV,
     *  RMASS,FODPIN,FODPOUT,ZODPIN,ZODPOUT,
     *  IDPZO,IDPFO,
     X  FDTMTH)
        CALL DP6MB(SBVL,
     *    RMASS,ZODPIN,ZODPOUT,FODPIN,FODPOUT,
     *    IDPZO,IDPFO)
C
      END IF
C
C
CMOC----COMPUTE NEW NODE AND PARTICLE CONCENTRATIONS AT END OF MOVE
      IF(ICONLY.NE.1.OR.NODISP.NE.1.OR.DIFFUS.NE.0.0)
     *  CALL MOC5AP(IBOUND,PC,PR,PL,PCONC,
     *    CONC,IGENPT,SUMC,CNCNC,NSCOL,NSROW,NSLAY,
     *    NPMAX,NCOL,NROW,NLAY,IOUTS,NP)
C
cellam
C SKIP IF MOC OR MOCIMP
      IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) GO TO 200
C SKIP TO HERE IF ELLAM
 100  CONTINUE
C
CELLAM---CLEAR MATRIX DIAGS, OUTFLOW DIAG AND RHSE
      CALL SMOC5Z(RHSE,NODESS,1,1,0.0)
      CALL SMOC5Z(RHSO,NTFACE,1,1,0.0)
      CALL SMOC5Z(DIAGO,NTFACE,1,1,0.0)
      IF (IIMOV.EQ.1) THEN
         NCOEF=0
         CALL SMOC5Z(DIAGST,27,NODESS,1,0.0)
         CALL SMOC5Z(DIAGDS,27,NODESS,1,0.0)
      ENDIF
C
CELLAM---CREATE BOUNDARY ARRAYS AND ACCUMULATE INFLOW MASS
      CALL ELLBDY(NSCOL,NSROW,NSLAY,NCOL,NROW,NLAY,
     *        CINFL,RHSE,RHSO,NODESS,IABOVE,IBELOW,NCINFL,
     *        IDBNDY,CTCFLO,LOCBDY,LBNDY,DIAGO,NFACES,NTFACE,
     *        VC,VR,VL,RF,
     *        THCK,POR,IBOUND,
     *        IOUTS,TIMV,TSTEP2,VCMAX,VRMAX,VLMAX,
     *        DELCOL,DELROW,XFOR,XBAC,YFOR,YBAC,DECAY,SRCDCY)
C
CELLAM---RHSE INTEGRATE CONCENTRATION AT OLD TIME LEVEL
CELLAM---LHS INTEGRATE CONCENTRATION AT NEW TIME LEVEL
        CALL BDYINT(IIMOV,NSCOL,NSROW,NSLAY,NCOL,NROW,NLAY,
     *      JRF,DELCOL,DELROW,THCK,
     *      IBOUND,NODESS,CNOLD,CBNDY,RHSE,RHSO,NTFACE,VC,VR,VL,RF,
     *      POR,TIMV,VCMAX,VRMAX,VLMAX,IOUTS,DIAGST,LBNDY,NZIN,
     *      NFACES,NONU,SAV,XFOR,XBAC,
     *      YFOR,YBAC,CINFL,NCINFL,IABOVE,IBELOW,DECAY,IDIM,NRFLG)
C
        CALL ELLLHI(IIMOV,NSCOL,NSROW,NSLAY,
     *   NODESS,NCOL,NROW,NLAY,IBOUND,CNOLD,DIAGST,XFOR,
     *   YFOR,THCK,IACT,CFOR,RFOR,TFOR,CONLAY,VOL,DELCOL,DELROW,
     *   RHSE,RHSO,LBNDY,NZIN,
     *   NTFACE,VC,VR,VL,RF,POR,TIMV,
     *   VCMAX,VRMAX,VLMAX,IOUTS,
     *   XBAC,YBAC,DECAY,NRFLG)
C
CELLAM---LHS BUILD DISPERSION INTEGRAL
      IF((IIMOV.EQ.1).AND.(NODISP.NE.1.OR.DIFFUS.NE.0.0)) 
     *   CALL ELLDIS(IBOUND,DISPCC,DISPCR,DISPCL,DISPRC,DISPRR,
     *      DISPRL,DISPLC,DISPLR,DISPLL,
     *      POR,THCK,RF,DIAGDS,TIMV,
     *      NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,NODESS,
     *      DELCOL,DELROW)
CELLAM---LHS AND RHSE BUILD SOURCE INTEGRAL
      IF(ICONLY.NE.1) CALL ELLSRC(IBOUND,SRCFLO,SRCSOL,SNKFLO,RF,
     *  THCK,POR,DIAGDS,RHSE,CNOLD,
     *  EVTFLO,IEVT,SRCDCY,NODESS,IIMOV,
     *  NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,NEVTOP,
     *  IOUTS,TIMV,DECAY,
     *  VC,VR,VL,VCMAX,VRMAX,VLMAX,
     *  LBNDY,NTFACE,RHSO,
     *  DELCOL,DELROW,XFOR,XBAC,YFOR,YBAC)
C
CELLAM---MOVE INFLOW CONCENTRATIONS TO INFLOW BNDY NODES
       IF(IIMOV.EQ.1) CALL ELIUPD(CBNDY,IDBNDY,CTCFLO,LOCBDY,
     *    CINFL,NCINFL,RF,
     *    IABOVE,IBELOW,CONC,NODESS,NTFACE,NFACES,NSCOL,NSROW,NSLAY,
     *    NCOL,NROW)
CELLAM---SOLVE FOR NEW CONCENTRATION ON OUTFLOW BOUNDARY,
C        MOVE OUTFLOW CBNDY * SAV TO RHSE, FOR OUTFLOW FACES
C        MOVE  INFLOW CBNDY * SAV TO RHSE, FOR INFLOW  FACES
C        ACCUMULATE MASS REPRESENTED BY BNDY NODE FOR MASS BALANCE
      CALL ELLOUT(CBNDY,DIAGO,RHSO,NONU,SAV,IDBNDY,RHSE,RF,ibound,
     *          NSCOL,NSROW,NSLAY,NTFACE,NODESS,JRF,NFACES,POR,cnold,
     *          NCOL,NROW,NLAY,NRFLG)
CELLAM---IF FIRST TRANSPORT TIME STEP,
C        CONVERT MATRICES,
C        FIND INITIAL MASS
C
      IF (IIMOV.EQ.1) THEN
       CALL CONVERT(NSCOL,NSROW,NSLAY,NODESS,DIAGST,DIAGDS,
     *       RWORK,LENW,JA,IA,A,NELT)
       CALL SMOC5I(JRF,NODES,NODESS,NSCOL,NSROW,NSLAY,
     *       NCOL,NROW,NLAY,NZIN,RWORK,JAS,IAS,AS,NELTS,
     *       RWORK,LENW,leniw,KKSTP,KKPER,
     *       CNOLD,RF,DIAGST,POR,IBOUND,SBVL,NRFLG,THCK)
      ENDIF 
C
CELLAM---SOLVE FOR NEW CONCENTRATION AT TRANSPORT SUBGRID NODES
      CALL ELLSLV(IBOUND,DIAGST,DIAGDS,
     *     RHSE,CONC,NCOL,NROW,NLAY,
     *     NODES,NODESS,NSCOL,NSROW,NSLAY,RWORK,LENW,IWORK,LENIW,
     *     IA,JA,A,NELT,iimov,nmov,
     *     delcol,delrow,thck,IOUTS)
C
CELLAM---MOVE INTERIOR NODE CONCENTRATION TO NOFLOW BNDY NODES
      CALL ELNUPD(CBNDY,LBNDY,CONC,NODESS,NTFACE,NFACES,
     *            NSCOL,NSROW,NSLAY)
C
C SKIP TO HERE IF MOC OR MOCIMP
 200  CONTINUE
cellam
      IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
CMOC----COMPUTE CUMULATIVE SOLUTE MASS BALANCE
       CALL SMOC6BD(IBOUND,RF,
     *  CONC,CNOLD,CFXHBC,CINFL,
     *  THCK,POR,CHDFLO,CTCFLO,LOCBDY,
     *  RECH,CRECH,IRCH,NRCHOP,
     *  WELL,MXWELL,NWELLS,NWELVL,IWELLC,
     *  RIVR,MXRIVR,NRIVER,NRIVVL,IRIVRC,
     *  DRAI,MXDRN,NDRAIN,NDRNVL,
     *  BNDS,MXBND,NBOUND,NGHBVL,IBNDSC,
     *  EVTFLO,IEVT,NEVTOP,
     *  IFLLOC,BDFV,NFLW,IFHBD4,IFHBFC,
     *  IHDLOC,BDHV,NHED,NFHBX2,IFHBHC,
     *  DECAY,TIMV,
     *  NCOL,NROW,NLAY,
     *  NSCOL,NSROW,NSLAY,
     *  IUNIT,IOUTS,NCINFL,JRF,SBVL,
     *  NFACES,IABOVE,IBELOW,MOCTYPE,
     *  DKFO,DKFS,JUNIT(11),IDKFO,IDKFS)
      ELSEIF(MOCTYPE.EQ.3) THEN
CMOC----COMPUTE CUMULATIVE SOLUTE MASS BALANCE (ELLAM)
       CALL SMOC6BE(IBOUND,RF,
     *  CONC,CBNDY,IDBNDY,
     *  CNOLD,CFXHBC,CINFL,
     *  THCK,POR,CHDFLO,CTCFLO,LOCBDY,
     *  RECH,CRECH,IRCH,NRCHOP,
     *  WELL,MXWELL,NWELLS,NWELVL,IWELLC,
     *  RIVR,MXRIVR,NRIVER,NRIVVL,IRIVRC,
     *  DRAI,MXDRN,NDRAIN,NDRNVL,
     *  BNDS,MXBND,NBOUND,NGHBVL,IBNDSC,
     *  EVTFLO,IEVT,NEVTOP,
     *  NZIN,RWORK,JAS,IAS,AS,NELTS,
     *  LENW,DECAY,TIMV,XFOR,XBAC,YFOR,YBAC,
     *  NCOL,NROW,NLAY,NODESS,NODES,
     *  NSCOL,NSROW,NSLAY,
     *  IUNIT,IOUTS,NCINFL,JRF,SBVL,NTFACE,
     *  NFACES,IABOVE,IBELOW,DELCOL,DELROW)
      ENDIF
cellam
C
CMOC----PRINT CONCENTRATION DATA
      CALL SMOC6C(CONC,THCK,SBVL,SRCDCY,
     *  KKSTP,NSTP,KKPER,NPER,IIMOV,NMOV,TIMV,
     *  DELCOL,DELROW,NCOL,NROW,NLAY,
     *  NSCOL,NSROW,NSLAY,IOUTS,JUNIT,PERTIM,TOTIM,SUMTCH,
     *  NPNTCL,ICONFM,ICONLY,
     *  IDKZO,IDKFO,IDKZS,IDKFS,
     *  IDPZO,IDPFO)
C
CDP----PRINT DOUBLE POROSITY CONCENTRATION DATA
      IF(JUNIT(10).GT.0.AND.IDPPS.NE.0) CALL SDP6C(DPCON,
     *    KKSTP,NSTP,KKPER,NPER,IIMOV,NMOV,
     *    NSCOL,NSROW,NSLAY,IOUTS,JUNIT,PERTIM,TOTIM,SUMTCH,
     *    NPNTCL,ICONFM,IDPPS)
C
CMOC----PRINT OBSERVATION DATA
      IF (IUNIT(15).GT.0.AND.JUNIT(8).GT.0) 
     *CALL SOBS5O(HNEW,CONC,SUMTCH,IOBLST,IIMOV,OBTEMP,
     *                  NSCOL,NSROW,NSLAY,NCOL,NROW,NLAY,NUMOBS,IOBSFL,
     *                  NPNTOB,KKSTP,NSTP,NMOV,KKPER,NPER)
C
CMOC----DUMP PARTICLE LOCATIONS
cgzh only if no ellam
      IF(IUNIT(15).GT.0.AND.JUNIT(4).GT.0.AND.MOCTYPE.NE.3)
     * CALL SMOC5P(PC,PR,PL,PCONC,
     *   JUNIT(4),KKPER,NPER,KKSTP,NSTP,IIMOV,NMOV,TIMV,NP,
     *      SUMTCH,NPNTPL,0)

      IF(IUNIT(15).GT.0.AND.JUNIT(5).GT.0.AND.MOCTYPE.NE.3)
     * CALL SMOC5P(PC,PR,PL,PCONC,
     *   JUNIT(5),KKPER,NPER,KKSTP,NSTP,IIMOV,NMOV,TIMV,NP,
     *      SUMTCH,NPNTPL,1)
C
      RETURN
      END
CMOC----END OF MOC6MVOT
